diff -crN nakedmudv1.0/src/scripts/pyroom.c nakedmudv1.4/src/scripts/pyroom.c
*** nakedmudv1.0/src/scripts/pyroom.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/scripts/pyroom.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,482 ----
+ //*****************************************************************************
+ //
+ // pyroom.c
+ //
+ // A python extention to allow python scripts to treat MUD characters as an
+ // object within the script.
+ //
+ //*****************************************************************************
+ 
+ #include <Python.h>
+ #include <structmember.h>
+ 
+ #include "../mud.h"
+ #include "../world.h"
+ #include "../room.h"
+ #include "../exit.h"
+ #include "../character.h"
+ #include "../races.h"
+ #include "../handler.h"
+ #include "../utils.h"
+ 
+ #include "script.h"
+ #include "pyroom.h"
+ #include "pychar.h"
+ #include "pyobj.h"
+ 
+ typedef struct {
+   PyObject_HEAD
+   room_vnum vnum;
+ } PyRoom;
+ 
+ 
+ //*****************************************************************************
+ //
+ // allocation, deallocation, and initialiation
+ //
+ //*****************************************************************************
+ static void
+ PyRoom_dealloc(PyRoom *self) {
+   self->ob_type->tp_free((PyObject*)self);
+ }
+ 
+ static PyObject *
+ PyRoom_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
+     PyRoom *self;
+ 
+     self = (PyRoom  *)type->tp_alloc(type, 0);
+     self->vnum = NOWHERE;
+     return (PyObject *)self;
+ }
+ 
+ static int
+ PyRoom_init(PyRoom *self, PyObject *args, PyObject *kwds) {
+   static char *kwlist[] = {"vnum", NULL};
+   int vnum = NOWHERE;
+ 
+   // get the vnum
+   if (!PyArg_ParseTupleAndKeywords(args, kwds, "i", kwlist, &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Rooms may only be created using a vnum");
+     return -1;
+   }
+ 
+   // make sure a room with the vnum exists
+   if(!worldGetRoom(gameworld, vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Rom with vnum, %d, does not exist", vnum);
+     return -1;
+   }
+ 
+   self->vnum = vnum;
+   return 0;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // methods and stuff for building the class
+ //
+ //*****************************************************************************
+ 
+ //
+ // close a door in the specified direction
+ //
+ static PyObject *
+ PyRoom_close(PyRoom *self, PyObject *value) {
+   ROOM_DATA *room = NULL;
+   EXIT_DATA *exit = NULL;
+   char *dirname = NULL;
+   int dir = DIR_NONE;
+ 
+   if (!PyArg_ParseTuple(value, "s", &dirname)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Doornames provided to PyRoom_close must be directions.");
+     return NULL;
+   }
+ 
+   room = worldGetRoom(gameworld, self->vnum);
+   if(room == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to close door in non-existant room, %d.", 
+ 		 self->vnum);
+     return NULL;
+   }
+ 
+   // see if it's a normal exit
+   dir = dirGetNum(dirname);
+ 
+   if(dir != DIR_NONE)
+     exit = roomGetExit(room, dir);
+   else
+     exit = roomGetExitSpecial(room, dirname);
+ 
+   // make sure the exit exists
+   if(exit == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to close non-existant exit, %s, in room %d.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   // make sure the exit can be closed in the first place
+   if(!exitIsClosable(exit)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to close exit, %s, in room %d that is not closable.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   exitSetClosed(exit, TRUE);
+   return Py_BuildValue("i", 1);
+ }
+ 
+ 
+ //
+ // lock a door in the specified direction
+ //
+ static PyObject *
+ PyRoom_lock(PyRoom *self, PyObject *value) {
+   ROOM_DATA *room = NULL;
+   EXIT_DATA *exit = NULL;
+   char *dirname = NULL;
+   int dir = DIR_NONE;
+ 
+   if (!PyArg_ParseTuple(value, "s", &dirname)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Doornames provided to PyRoom_lock must be directions.");
+     return NULL;
+   }
+ 
+   room = worldGetRoom(gameworld, self->vnum);
+   if(room == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to lock door in non-existant room, %d.", 
+ 		 self->vnum);
+     return NULL;
+   }
+ 
+   // see if it's a normal exit
+   dir = dirGetNum(dirname);
+ 
+   if(dir != DIR_NONE)
+     exit = roomGetExit(room, dir);
+   else
+     exit = roomGetExitSpecial(room, dirname);
+ 
+   // make sure the exit exists
+   if(exit == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to lock non-existant exit, %s, in room %d.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   // make sure the exit can be closed in the first place
+   if(!exitIsClosable(exit)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to lock exit, %s, in room %d that is not closable.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+   if(exitGetKey(exit) == NOTHING) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to lock exit, %s, in room %d that is not lockable.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   exitSetClosed(exit, TRUE);
+   exitSetLocked(exit, TRUE);
+   return Py_BuildValue("i", 1);
+ }
+ 
+ 
+ //
+ // lock a door in the specified direction
+ //
+ static PyObject *
+ PyRoom_unlock(PyRoom *self, PyObject *value) {
+   ROOM_DATA *room = NULL;
+   EXIT_DATA *exit = NULL;
+   char *dirname = NULL;
+   int dir = DIR_NONE;
+ 
+   if (!PyArg_ParseTuple(value, "s", &dirname)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Doornames provided to PyRoom_unlock must be directions.");
+     return NULL;
+   }
+ 
+   room = worldGetRoom(gameworld, self->vnum);
+   if(room == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to unlock door in non-existant room, %d.", 
+ 		 self->vnum);
+     return NULL;
+   }
+ 
+   // see if it's a normal exit
+   dir = dirGetNum(dirname);
+ 
+   if(dir != DIR_NONE)
+     exit = roomGetExit(room, dir);
+   else
+     exit = roomGetExitSpecial(room, dirname);
+ 
+   // make sure the exit exists
+   if(exit == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to unlock non-existant exit, %s, in room %d.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   // make sure the exit can be closed in the first place
+   if(!exitIsClosable(exit)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to unlock exit, %s, in room %d that is not closable.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+   if(exitGetKey(exit) == NOTHING) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to unlock exit, %s, in room %d that is not lockable.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   exitSetLocked(exit, FALSE);
+   return Py_BuildValue("i", 1);
+ }
+ 
+ 
+ //
+ // close a door in the specified direction
+ //
+ static PyObject *
+ PyRoom_open(PyRoom *self, PyObject *value) {
+   ROOM_DATA *room = NULL;
+   EXIT_DATA *exit = NULL;
+   char *dirname = NULL;
+   int dir = DIR_NONE;
+ 
+   if (!PyArg_ParseTuple(value, "s", &dirname)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Doornames provided to PyRoom_open must be directions.");
+     return NULL;
+   }
+ 
+   room = worldGetRoom(gameworld, self->vnum);
+   if(room == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to open door in non-existant room, %d.", 
+ 		 self->vnum);
+     return NULL;
+   }
+ 
+ 
+   // see if it's a normal exit
+   dir = dirGetNum(dirname);
+ 
+   if(dir != DIR_NONE)
+     exit = roomGetExit(room, dir);
+   else
+     exit = roomGetExitSpecial(room, dirname);
+ 
+   // make sure the exit exists
+   if(exit == NULL) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to open non-existant exit, %s, in room %d.",
+ 		 dirname, self->vnum);
+     return NULL;
+   }
+ 
+   exitSetClosed(exit, FALSE);
+   exitSetLocked(exit, FALSE);
+   return Py_BuildValue("i", 1);
+ }
+ 
+ 
+ 
+ static PyMethodDef PyRoom_methods[] = {
+     {"close", (PyCFunction)PyRoom_close, METH_VARARGS,
+      "close a door in the specified direction." },
+     {"open", (PyCFunction)PyRoom_open, METH_VARARGS,
+      "open a door in the specified direction. Unlocks it if neccessary." },
+     {"lock", (PyCFunction)PyRoom_lock, METH_VARARGS,
+      "lock a door in the specified direction, closing it if it is open." },
+     {"unlock", (PyCFunction)PyRoom_unlock, METH_VARARGS,
+      "unlocks the door in the specified direction." },
+     {NULL}  /* Sentinel */
+ };
+ 
+ 
+ //*****************************************************************************
+ //
+ // character attributes - mostly get and set
+ //
+ //*****************************************************************************
+ static PyObject *
+ PyRoom_getvnum(PyRoom *self, void *closure) {
+   ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+   if(room != NULL) return Py_BuildValue("i", roomGetVnum(room));
+   else             return NULL;
+ }
+ 
+ static PyObject *
+ PyRoom_getcharacters(PyRoom *self, PyObject *args) {
+   ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+   if(room == NULL)
+     return NULL;
+   else {
+     LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
+     PyObject *list = PyList_New(0);
+     CHAR_DATA *ch;
+ 
+     // for each char in the room list, add him to a Python list
+     ITERATE_LIST(ch, char_i)
+       PyList_Append(list, newPyChar(ch));
+     deleteListIterator(char_i);
+     return Py_BuildValue("O", list);
+   }
+ }
+ 
+ static PyObject *
+ PyRoom_getcontents(PyRoom *self, PyObject *args) {
+   ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+   if(room == NULL)
+     return NULL;
+   else {
+     LIST_ITERATOR *obj_i = newListIterator(roomGetContents(room));
+     PyObject *list = PyList_New(0);
+     OBJ_DATA *obj;
+ 
+     // for each obj in the room list, add him to a Python list
+     ITERATE_LIST(obj, obj_i)
+       PyList_Append(list, newPyObj(obj));
+     deleteListIterator(obj_i);
+     return Py_BuildValue("O", list);
+   }
+ }
+ 
+ 
+ static PyGetSetDef PyRoom_getseters[] = {
+   {"vnum", (getter)PyRoom_getvnum, (setter)NULL,
+    "The room's vnum", NULL},
+   {"chars", (getter)PyRoom_getcharacters, (setter)NULL,
+    "The characters in the room", NULL},
+   {"objs", (getter)PyRoom_getcontents, (setter)NULL,
+    "The objects in the room", NULL},
+   {"contents", (getter)PyRoom_getcontents, (setter)NULL,
+    "The objects in the room", NULL},
+   {NULL}  /* Sentinel */
+ };
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // comparators, getattr, setattr, and all that other class stuff
+ //
+ //*****************************************************************************
+ 
+ //
+ // compare one character to another
+ //
+ static int
+ PyRoom_compare(PyRoom *room1, PyRoom *room2) {
+   if(room1->vnum == room2->vnum)
+     return 0;
+   else if(room1->vnum < room2->vnum)
+     return -1;
+   else
+     return 1;
+ }
+ 
+ static PyTypeObject PyRoom_Type = {
+     PyObject_HEAD_INIT(NULL)
+     0,                         /*ob_size*/
+     "room.Room",               /*tp_name*/
+     sizeof(PyRoom),            /*tp_basicsize*/
+     0,                         /*tp_itemsize*/
+     (destructor)PyRoom_dealloc,/*tp_dealloc*/
+     0,                         /*tp_print*/
+     0,                         /*tp_getattr*/
+     0,                         /*tp_setattr*/
+     (cmpfunc)PyRoom_compare,   /*tp_compare*/
+     0,                         /*tp_repr*/
+     0,                         /*tp_as_number*/
+     0,                         /*tp_as_sequence*/
+     0,                         /*tp_as_mapping*/
+     0,                         /*tp_hash */
+     0,                         /*tp_call*/
+     0,                         /*tp_str*/
+     0,                         /*tp_getattro*/
+     0,                         /*tp_setattro*/
+     0,                         /*tp_as_buffer*/
+     Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
+     "Python Room object",      /* tp_doc */
+     0,		               /* tp_traverse */
+     0,		               /* tp_clear */
+     0,		               /* tp_richcompare */
+     0,		               /* tp_weaklistoffset */
+     0,		               /* tp_iter */
+     0,		               /* tp_iternext */
+     PyRoom_methods,            /* tp_methods */
+     0,                         /* tp_members */
+     PyRoom_getseters,          /* tp_getset */
+     0,                         /* tp_base */
+     0,                         /* tp_dict */
+     0,                         /* tp_descr_get */
+     0,                         /* tp_descr_set */
+     0,                         /* tp_dictoffset */
+     (initproc)PyRoom_init,    /* tp_init */
+     0,                         /* tp_alloc */
+     PyRoom_new,               /* tp_new */
+ };
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // the room module
+ //
+ //*****************************************************************************
+ static PyMethodDef room_module_methods[] = {
+   {NULL, NULL, 0, NULL}  /* Sentinel */
+ };
+ 
+ 
+ PyMODINIT_FUNC
+ init_PyRoom(void) {
+     PyObject* m;
+ 
+     if (PyType_Ready(&PyRoom_Type) < 0)
+         return;
+ 
+     m = Py_InitModule3("room", room_module_methods,
+                        "The room module, for all MUD room-related stuff.");
+ 
+     if (m == NULL)
+       return;
+ 
+     Py_INCREF(&PyRoom_Type);
+     PyModule_AddObject(m, "Room", (PyObject *)&PyRoom_Type);
+ }
+ 
+ int PyRoom_AsVnum(PyObject *room) {
+   return ((PyRoom *)room)->vnum;
+ }
+ 
+ int PyRoom_Check(PyObject *value) {
+   return PyObject_TypeCheck(value, &PyRoom_Type);
+ }
+ 
+ PyObject *
+ newPyRoom(ROOM_DATA *room) {
+   PyRoom *py_room = (PyRoom *)PyRoom_new(&PyRoom_Type, NULL, NULL);
+   py_room->vnum = roomGetVnum(room);
+   return (PyObject *)py_room;
+ }
diff -crN nakedmudv1.0/src/scripts/pyroom.h nakedmudv1.4/src/scripts/pyroom.h
*** nakedmudv1.0/src/scripts/pyroom.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/scripts/pyroom.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,22 ----
+ #ifndef __PYROOM_H
+ #define __PYROOM_H
+ //*****************************************************************************
+ //
+ // pyroom.h
+ //
+ // A python extention to allow python scripts to treat MUD rooms as an
+ // object within the script.
+ //
+ //*****************************************************************************
+ 
+ /* initialize characters for use */
+ PyMODINIT_FUNC
+ init_PyRoom(void);
+ 
+ int PyRoom_AsVnum(PyObject *room);
+ int PyRoom_Check(PyObject *value);
+ 
+ PyObject *
+ newPyRoom(ROOM_DATA *room);
+ 
+ #endif //__PYROOM_H
diff -crN nakedmudv1.0/src/scripts/README nakedmudv1.4/src/scripts/README
*** nakedmudv1.0/src/scripts/README	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/scripts/README	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,182 ----
+ If you are having problems installing scripts, you will want to read the 
+ documentation in src/modules/scripts/Makefile. This file is an explanation of
+ how to interact with scripts.
+ 
+ Scripting is a powerful method for adding character to your MUD. It essentially
+ allows you to edit (simple) code that will modify the way rooms, players, and
+ objects work. This scripting module uses Python (http://www.python.org) to run
+ scripts. It will probably be a good idea to get an understanding of the basic
+ python syntax before doing any scripting. Python is a relatively easy language
+ to learn - even for non-programmers - and that was why it was chosen as the
+ scripting language.
+ 
+ The scripting module for NakedMud adds a couple things to Python, so that it can
+ interact with the different types of data in the MUD (see pychar.c, pyobj.c,
+ pyroom.c, and pymud.c). Below is a quick synopsis of the various ways Python
+ can work with the MUD's data. For documentation on what specific script types
+ are used for, and how, see script.h in this directory.
+ 
+ 
+ 
+ ********************************************************************************
+ ****************************** PYTHON CHARACTERS *******************************
+ ********************************************************************************
+ The following variables are accessable on Python characters:
+   ch.inv         return a list of the items in the character's inventory
+   ch.objs        same as ch.inv
+   ch.is_npc      return true or false if the character is an NPC
+   ch.is_pc       return true or false if the character is a PC
+   ch.uid         get the character's unique ID (not settable)
+   ch.name        get/set a character's name
+   ch.desc        get/set a character's description
+   ch.rdesc       get/set a character's room description
+   ch.level       get/set a character's level
+   ch.on          get/set the furniture the character is sitting on
+   ch.vnum        get/set the character's virtual number
+   ch.sex         get/set a character's sex. Sex must be in string form 
+                  (e.g. 'male', 'female', or 'neutral')
+   ch.race        get/set a character's race. Race must be in string form
+                  (e.g. 'human', 'elf', 'dragon')
+   ch.position    get/set a character's position. Position must be in string form
+                  (e.g. 'sitting', 'standing')
+   ch.room        get/set a character's room. When setting, a room, either
+                  a room vnum can be used, or an actual room object (see pyroom).
+ 
+ 
+ The following functions are available for use with Python characters:
+   
+ SENDING MESSAGES
+ ch.send('message')
+ example: ch.send('hello, world!')
+ Send a character a text message.
+ 
+ PERFORMING ACTIONS
+ ch.act('command')
+ example: ch.act('say hello, world!')
+ Force a character to perform a specific action.
+ 
+ STORING SCRIPT DATA
+ ch.setvar('varname', value)
+ example: ch.setvar('blackjack_winnings', 100)
+ Allows you to store information on a character, regarding stuff that happened
+ during the script. These variables save over reboots and crashes. The only
+ restriction is that the variables must be integer values.
+ 
+ RETRIEVING SCRIPT DATA
+ ch.getvar('varname')
+ example: winnings = ch.getvar('blackjack_winnings')
+ Retrieve set data. If the variable has not been set yet, 0 is returned.
+ 
+ LOADING NEW MOBILES
+ load_mob(vnum, to)
+ example: new_mob = load_mob(100, 120)
+ Load a new mobile to the specified target. The first value is the mob's vnum
+ and the second is what you would like to load the mob to. "to" can be a room,
+ a room vnum, or a piece of furniture.
+ 
+ COUNTING OCCURANCES OF MOBILES
+ count_mob(vnum/name, where = entire game)
+ exmaple: room_pcs = count_mobs(-1, 100)
+ Count the occurances of the number of mobs that are in the scope of where. Where
+ can be either a room, a room vnum, or a piece of furniture. if where is not
+ provided (e.g. count_mobs('jim')) then all characters in the entire game are
+ looked over for matches. Either a mob vnum can be used, or the mob's name. If
+ a vnum if -1 is used, PCs are counted.
+ 
+ 
+ 
+ ********************************************************************************
+ ******************************** PYTHON OBJECTS ********************************
+ ********************************************************************************
+ The following variables are accessable on Python mud objects:
+   obj.contents    return a list of the things stored within the object
+   obj.objs        same as obj.contents
+   obj.chars       return the people sitting on the object
+   obj.uid         return the unique ID of the object. Not settable
+   obj.name        get/set the object's name
+   obj.desc        get/set the object's description
+   obj.rdesc       get/set the object's room description
+   obj.vnum        get/set the object's vnum
+ 
+ 
+ The following functions are available for use with Python mud objects:
+ LOADING NEW OBJECTS
+ load_obj(vnum, where, bodypart = NONE)
+ Load an object with the specified vnum to "where". Where can be a container,
+ a room, or a character. If a character is provided but a list of bodyparts
+ is not, then the object is loaded to inventory. If a list of bodyparts are
+ provided, the mobile will try to equip the object to those bodyparts. If, for
+ bodyparts, an empty string (e.g. '') is used, then the mobile will try to
+ equip the item to the first open, viable slots.
+ 
+ COUNTING OBJECTS
+ count_objs(vnum/name, where = entire game)
+ exmaple: inv_items = count_objs(141, ch)
+ Count the occurances of the number of objects that are in the scope of where. 
+ Where can be a room, a room vnum, a container, or a character. If where is not
+ provided (e.g. count_objs('table')) then all objects in the entire game are
+ looked over for matches. Either a obj vnum can be used, or the objects's name. 
+ 
+ 
+ 
+ ********************************************************************************
+ ********************************* PYTHON ROOMS *********************************
+ ********************************************************************************
+ The following variables are accessable on Python rooms:
+   room.chars      return a list of characters in the room
+   room.contents   return a lsit of objects in the room
+   room.objs       same as room.contents
+   room.vnum       return the virtual number of the room
+ 
+ 
+ The following functions are available for use with Python mud objects:
+ CLOSING DOORS
+ room.close('direction')
+ example: room.close('north')
+ Try to close the door in a specified direction, if a door and direction exist.
+ If the door was previously locked, it is unlocked.
+ 
+ OPENING DOORS
+ room.open('direction')
+ example: room.open('east')
+ Try to open the door in a specified direction, if a door and direction exist.
+ If the door was previously locked, it is unlocked.
+ 
+ LOCKING DOORS
+ room.lock('direction')
+ example: room.lock('up')
+ Try to lock the door in a specified direction, if a door and direction exist.
+ If the door was previously open, it is closed.
+ 
+ UNLOCKING DOORS
+ room.unlock('direction')
+ example: room.unlock('down')
+ Try to unlock the door in a specified direction, if a door and direction exist.
+ 
+ 
+ 
+ ********************************************************************************
+ ******************************* GLOBAL VARIABLES *******************************
+ ********************************************************************************
+ There are times when one might want to save a piece of information, but not
+ specifically on a character. Global variables allow for this. In addition,
+ global variables can be ANY type of value (string, integer, a character, a
+ room, you name it). However, global variables do not save over crashes.
+ 
+ SETTING GLOBAL VARIABLES
+ set_global('key', val)
+ example: set_global('bobs_killer', ch)
+ Allows you to store the value of a variable globally, which can be accessed
+ by other scripts, or by the same script at a later time.
+ 
+ RETREIVING THE VALUES OF GLOBAL VARIABLES
+ get_global('key')
+ example: killer = get_global('bobs_killer')
+ Retreive the value of a global variable. If the variable has not been set,
+ then None is returned.
+ 
+ ERASING A GLOBAL VARIABLE
+ erase_global('key')
+ example: erase_global('bobs_killer')
+ Erase the value of the global variable. Effectively, this is the same as
+ setting the variable's value to None.
